diff --git a/dlls/dinput/dinput_private.h b/dlls/dinput/dinput_private.h
index c0c88da9674..e9205234a65 100644
--- a/dlls/dinput/dinput_private.h
+++ b/dlls/dinput/dinput_private.h
@@ -71,9 +71,9 @@ extern const struct dinput_device joystick_osx_device DECLSPEC_HIDDEN;
 
 extern void dinput_hooks_acquire_device(LPDIRECTINPUTDEVICE8W iface);
 extern void dinput_hooks_unacquire_device(LPDIRECTINPUTDEVICE8W iface);
-extern int dinput_mouse_hook(LPDIRECTINPUTDEVICE8A iface, WPARAM wparam, LPARAM lparam);
-extern int dinput_keyboard_hook(LPDIRECTINPUTDEVICE8A iface, WPARAM wparam, LPARAM lparam);
-extern void dinput_mouse_rawinput_hook( LPDIRECTINPUTDEVICE8A iface, WPARAM wparam, LPARAM lparam, RAWINPUT *raw );
+extern int dinput_mouse_hook(IDirectInputDevice8W *iface, WPARAM wparam, LPARAM lparam);
+extern int dinput_keyboard_hook(IDirectInputDevice8W *iface, WPARAM wparam, LPARAM lparam);
+extern void dinput_mouse_rawinput_hook( IDirectInputDevice8W *iface, WPARAM wparam, LPARAM lparam, RAWINPUT *raw );
 
 extern void check_dinput_hooks(LPDIRECTINPUTDEVICE8W, BOOL) DECLSPEC_HIDDEN;
 extern void check_dinput_events(void) DECLSPEC_HIDDEN;
diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index 497bde4a293..fcc968f0d71 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -60,22 +60,10 @@ const GUID DInput_PIDVID_Product_GUID = { /* device_pidvid-0000-0000-0000-504944
     0x00000000, 0x0000, 0x0000, {0x00, 0x00, 0x50, 0x49, 0x44, 0x56, 0x49, 0x44}
 };
 
-static inline JoystickGenericImpl *impl_from_IDirectInputDevice8A(IDirectInputDevice8A *iface)
-{
-    return CONTAINING_RECORD(CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8A_iface), JoystickGenericImpl, base);
-}
 static inline JoystickGenericImpl *impl_from_IDirectInputDevice8W(IDirectInputDevice8W *iface)
 {
     return CONTAINING_RECORD(CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8W_iface), JoystickGenericImpl, base);
 }
-static inline IDirectInputDevice8A *IDirectInputDevice8A_from_impl(JoystickGenericImpl *This)
-{
-    return &This->base.IDirectInputDevice8A_iface;
-}
-static inline IDirectInputDevice8W *IDirectInputDevice8W_from_impl(JoystickGenericImpl *This)
-{
-    return &This->base.IDirectInputDevice8W_iface;
-}
 
 DWORD typeFromGUID(REFGUID guid)
 {
@@ -701,7 +689,7 @@ HRESULT WINAPI JoystickWGenericImpl_Poll(LPDIRECTINPUTDEVICE8W iface)
         return DIERR_NOTACQUIRED;
     }
 
-    This->joy_polldev(IDirectInputDevice8A_from_impl(This));
+    This->joy_polldev(iface);
     return DI_OK;
 }
 
@@ -721,7 +709,7 @@ HRESULT WINAPI JoystickWGenericImpl_GetDeviceState(LPDIRECTINPUTDEVICE8W iface,
     }
 
     /* update joystick state */
-    This->joy_polldev(IDirectInputDevice8A_from_impl(This));
+    This->joy_polldev(iface);
 
     /* convert and copy data to user supplied buffer */
     fill_DataFormat(ptr, len, &This->js, &This->base.data_format);
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index 29066f514cc..76e7e2bcaab 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -102,22 +102,12 @@ struct JoystickImpl
         POINTL                          povs[4];
 };
 
-static inline JoystickImpl *impl_from_IDirectInputDevice8A(IDirectInputDevice8A *iface)
-{
-    return CONTAINING_RECORD(CONTAINING_RECORD(CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8A_iface),
-           JoystickGenericImpl, base), JoystickImpl, generic);
-}
 static inline JoystickImpl *impl_from_IDirectInputDevice8W(IDirectInputDevice8W *iface)
 {
     return CONTAINING_RECORD(CONTAINING_RECORD(CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8W_iface),
            JoystickGenericImpl, base), JoystickImpl, generic);
 }
 
-static inline IDirectInputDevice8W *IDirectInputDevice8W_from_impl(JoystickImpl *This)
-{
-    return &This->generic.base.IDirectInputDevice8W_iface;
-}
-
 static const GUID DInput_Wine_Joystick_GUID = { /* 9e573ed9-7734-11d2-8d4a-23903fb6bdf7 */
   0x9e573ed9,
   0x7734,
@@ -129,7 +119,7 @@ static const GUID DInput_Wine_Joystick_GUID = { /* 9e573ed9-7734-11d2-8d4a-23903
 static INT joystick_devices_count = -1;
 static struct JoyDev *joystick_devices;
 
-static void joy_polldev(LPDIRECTINPUTDEVICE8A iface);
+static void joy_polldev(IDirectInputDevice8W *iface);
 
 #define SYS_PATH_FORMAT "/sys/class/input/js%d/device/id/%s"
 static BOOL read_sys_id_variable(int index, const char *property, WORD *value)
@@ -793,11 +783,11 @@ static HRESULT WINAPI JoystickLinuxWImpl_Unacquire(LPDIRECTINPUTDEVICE8W iface)
     return DI_NOEFFECT;
 }
 
-static void joy_polldev(LPDIRECTINPUTDEVICE8A iface)
+static void joy_polldev(IDirectInputDevice8W *iface)
 {
     struct pollfd plfd;
     struct js_event jse;
-    JoystickImpl *This = impl_from_IDirectInputDevice8A(iface);
+    JoystickImpl *This = impl_from_IDirectInputDevice8W(iface);
 
     TRACE("(%p)\n", This);
 
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index b285369f80f..a39b727e278 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -136,25 +136,15 @@ struct JoystickImpl
 	int				ff_gain;
 };
 
-static inline JoystickImpl *impl_from_IDirectInputDevice8A(IDirectInputDevice8A *iface)
-{
-    return CONTAINING_RECORD(CONTAINING_RECORD(CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8A_iface),
-           JoystickGenericImpl, base), JoystickImpl, generic);
-}
 static inline JoystickImpl *impl_from_IDirectInputDevice8W(IDirectInputDevice8W *iface)
 {
     return CONTAINING_RECORD(CONTAINING_RECORD(CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8W_iface),
            JoystickGenericImpl, base), JoystickImpl, generic);
 }
 
-static inline IDirectInputDevice8W *IDirectInputDevice8W_from_impl(JoystickImpl *This)
-{
-    return &This->generic.base.IDirectInputDevice8W_iface;
-}
-
 static void fake_current_js_state(JoystickImpl *ji);
 static void find_joydevs(void);
-static void joy_polldev(LPDIRECTINPUTDEVICE8A iface);
+static void joy_polldev(IDirectInputDevice8W *iface);
 
 /* This GUID is slightly different from the linux joystick one. Take note. */
 static const GUID DInput_Wine_Joystick_Base_GUID = { /* 9e573eda-7734-11d2-8d4a-23903fb6bdf7 */
@@ -788,11 +778,11 @@ static void fake_current_js_state(JoystickImpl *ji)
 #undef CENTER_AXIS
 
 /* convert wine format offset to user format object index */
-static void joy_polldev(LPDIRECTINPUTDEVICE8A iface)
+static void joy_polldev(IDirectInputDevice8W *iface)
 {
     struct pollfd plfd;
     struct input_event ie;
-    JoystickImpl *This = impl_from_IDirectInputDevice8A(iface);
+    JoystickImpl *This = impl_from_IDirectInputDevice8W(iface);
 
     if (This->joyfd==-1)
 	return;
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index 8dde986be3e..0d14de6ba58 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -113,22 +113,12 @@ struct JoystickImpl
     struct list effects;
 };
 
-static inline JoystickImpl *impl_from_IDirectInputDevice8A(IDirectInputDevice8A *iface)
-{
-    return CONTAINING_RECORD(CONTAINING_RECORD(CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8A_iface),
-           JoystickGenericImpl, base), JoystickImpl, generic);
-}
 static inline JoystickImpl *impl_from_IDirectInputDevice8W(IDirectInputDevice8W *iface)
 {
     return CONTAINING_RECORD(CONTAINING_RECORD(CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8W_iface),
            JoystickGenericImpl, base), JoystickImpl, generic);
 }
 
-static inline IDirectInputDevice8W *IDirectInputDevice8W_from_impl(JoystickImpl *This)
-{
-    return &This->generic.base.IDirectInputDevice8W_iface;
-}
-
 typedef struct _EffectImpl {
     IDirectInputEffect IDirectInputEffect_iface;
     LONG ref;
@@ -766,9 +756,9 @@ static void get_osx_device_elements_props(JoystickImpl *device)
     }
 }
 
-static void poll_osx_device_state(LPDIRECTINPUTDEVICE8A iface)
+static void poll_osx_device_state(IDirectInputDevice8W *iface)
 {
-    JoystickImpl *device = impl_from_IDirectInputDevice8A(iface);
+    JoystickImpl *device = impl_from_IDirectInputDevice8W(iface);
     IOHIDElementRef device_main_element;
     IOHIDDeviceRef hid_device;
 
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index 8bb683c20f4..5327fa60566 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -33,7 +33,7 @@
 #define MAX_PROPS 164
 struct JoystickGenericImpl;
 
-typedef void joy_polldev_handler(LPDIRECTINPUTDEVICE8A iface);
+typedef void joy_polldev_handler(IDirectInputDevice8W *iface);
 
 typedef struct JoystickGenericImpl
 {
diff --git a/dlls/dinput/keyboard.c b/dlls/dinput/keyboard.c
index 663806360b5..63952f1f3ff 100644
--- a/dlls/dinput/keyboard.c
+++ b/dlls/dinput/keyboard.c
@@ -50,22 +50,10 @@ struct SysKeyboardImpl
     DWORD subtype;
 };
 
-static inline SysKeyboardImpl *impl_from_IDirectInputDevice8A(IDirectInputDevice8A *iface)
-{
-    return CONTAINING_RECORD(CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8A_iface), SysKeyboardImpl, base);
-}
 static inline SysKeyboardImpl *impl_from_IDirectInputDevice8W(IDirectInputDevice8W *iface)
 {
     return CONTAINING_RECORD(CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8W_iface), SysKeyboardImpl, base);
 }
-static inline IDirectInputDevice8A *IDirectInputDevice8A_from_impl(SysKeyboardImpl *This)
-{
-    return &This->base.IDirectInputDevice8A_iface;
-}
-static inline IDirectInputDevice8W *IDirectInputDevice8W_from_impl(SysKeyboardImpl *This)
-{
-    return &This->base.IDirectInputDevice8W_iface;
-}
 
 static BYTE map_dik_code(DWORD scanCode, DWORD vkCode, DWORD subType, DWORD version)
 {
@@ -102,9 +90,9 @@ static BYTE map_dik_code(DWORD scanCode, DWORD vkCode, DWORD subType, DWORD vers
     return scanCode;
 }
 
-int dinput_keyboard_hook( LPDIRECTINPUTDEVICE8A iface, WPARAM wparam, LPARAM lparam )
+int dinput_keyboard_hook( IDirectInputDevice8W *iface, WPARAM wparam, LPARAM lparam )
 {
-    SysKeyboardImpl *This = impl_from_IDirectInputDevice8A(iface);
+    SysKeyboardImpl *This = impl_from_IDirectInputDevice8W(iface);
     int dik_code, ret = This->base.dwCoopLevel & DISCL_EXCLUSIVE;
     KBDLLHOOKSTRUCT *hook = (KBDLLHOOKSTRUCT *)lparam;
     BYTE new_diks;
@@ -522,7 +510,7 @@ static HRESULT WINAPI SysKeyboardWImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface,
         case (DWORD_PTR) DIPROP_RANGE:
             return DIERR_UNSUPPORTED;
         default:
-            return IDirectInputDevice2WImpl_GetProperty(IDirectInputDevice8W_from_impl(This), rguid, pdiph);
+            return IDirectInputDevice2WImpl_GetProperty(iface, rguid, pdiph);
     }
     return DI_OK;
 }
diff --git a/dlls/dinput/mouse.c b/dlls/dinput/mouse.c
index 2fa055cf8c9..57da24ddee5 100644
--- a/dlls/dinput/mouse.c
+++ b/dlls/dinput/mouse.c
@@ -77,20 +77,11 @@ struct SysMouseImpl
     WARP_MOUSE                      warp_override;
 };
 
-static inline SysMouseImpl *impl_from_IDirectInputDevice8A(IDirectInputDevice8A *iface)
-{
-    return CONTAINING_RECORD(CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8A_iface), SysMouseImpl, base);
-}
 static inline SysMouseImpl *impl_from_IDirectInputDevice8W(IDirectInputDevice8W *iface)
 {
     return CONTAINING_RECORD(CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8W_iface), SysMouseImpl, base);
 }
 
-static inline IDirectInputDevice8W *IDirectInputDevice8W_from_impl(SysMouseImpl *This)
-{
-    return &This->base.IDirectInputDevice8W_iface;
-}
-
 static void _dump_mouse_state(const DIMOUSESTATE2 *m_state)
 {
     int i;
@@ -305,9 +296,9 @@ const struct dinput_device mouse_device = {
  *	SysMouseA (DInput Mouse support)
  */
 
-void dinput_mouse_rawinput_hook( LPDIRECTINPUTDEVICE8A iface, WPARAM wparam, LPARAM lparam, RAWINPUT *ri )
+void dinput_mouse_rawinput_hook( IDirectInputDevice8W *iface, WPARAM wparam, LPARAM lparam, RAWINPUT *ri )
 {
-    SysMouseImpl* This = impl_from_IDirectInputDevice8A( iface );
+    SysMouseImpl* This = impl_from_IDirectInputDevice8W( iface );
     POINT rel, pt;
     DWORD seq;
     int i, wdata = 0;
@@ -389,10 +380,10 @@ void dinput_mouse_rawinput_hook( LPDIRECTINPUTDEVICE8A iface, WPARAM wparam, LPA
 }
 
 /* low-level mouse hook */
-int dinput_mouse_hook( LPDIRECTINPUTDEVICE8A iface, WPARAM wparam, LPARAM lparam )
+int dinput_mouse_hook( IDirectInputDevice8W *iface, WPARAM wparam, LPARAM lparam )
 {
     MSLLHOOKSTRUCT *hook = (MSLLHOOKSTRUCT *)lparam;
-    SysMouseImpl* This = impl_from_IDirectInputDevice8A(iface);
+    SysMouseImpl* This = impl_from_IDirectInputDevice8W(iface);
     int wdata = 0, inst_id = -1, ret = 0;
 
     TRACE("msg %lx @ (%d %d)\n", wparam, hook->pt.x, hook->pt.y);
-- 
2.28.0

>From aa2d90db1c316226efcc34cb076a7e5aab791767 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Mon, 5 Oct 2020 12:44:47 +0200
Subject: [PATCH 04/39] dinput: Remove unicode parameter from create_device.

---
 dlls/dinput/dinput_main.c         | 17 ++++++++---------
 dlls/dinput/dinput_private.h      |  2 +-
 dlls/dinput/joystick_linux.c      |  9 ++++-----
 dlls/dinput/joystick_linuxinput.c |  9 ++++-----
 dlls/dinput/joystick_osx.c        |  9 ++++-----
 dlls/dinput/keyboard.c            | 10 ++++------
 dlls/dinput/mouse.c               |  9 ++++-----
 7 files changed, 29 insertions(+), 36 deletions(-)

diff --git a/dlls/dinput/dinput_main.c b/dlls/dinput/dinput_main.c
index e3b6eeee3eb..c8ff3bd8bec 100644
--- a/dlls/dinput/dinput_main.c
+++ b/dlls/dinput/dinput_main.c
@@ -850,7 +850,7 @@ static HRESULT WINAPI IDirectInput2WImpl_FindDevice(LPDIRECTINPUT7W iface, REFGU
     return DI_OK;
 }
 
-static HRESULT create_device(IDirectInputImpl *This, REFGUID rguid, REFIID riid, LPVOID *pvOut, BOOL unicode)
+static HRESULT create_device(IDirectInputImpl *This, REFGUID rguid, REFIID riid, LPVOID *pvOut)
 {
     unsigned int i;
 
@@ -869,8 +869,7 @@ static HRESULT create_device(IDirectInputImpl *This, REFGUID rguid, REFIID riid,
         HRESULT ret;
 
         if (!dinput_devices[i]->create_device) continue;
-        if ((ret = dinput_devices[i]->create_device(This, rguid, riid, pvOut, unicode)) == DI_OK)
-            return DI_OK;
+        if ((ret = dinput_devices[i]->create_device(This, rguid, riid, pvOut)) == DI_OK) return DI_OK;
     }
 
     WARN("invalid device GUID %s\n", debugstr_guid(rguid));
@@ -884,7 +883,7 @@ static HRESULT WINAPI IDirectInput7AImpl_CreateDeviceEx(LPDIRECTINPUT7A iface, R
 
     TRACE("(%p)->(%s, %s, %p, %p)\n", This, debugstr_guid(rguid), debugstr_guid(riid), pvOut, lpUnknownOuter);
 
-    return create_device(This, rguid, riid, pvOut, FALSE);
+    return create_device(This, rguid, riid, pvOut);
 }
 
 static HRESULT WINAPI IDirectInput7WImpl_CreateDeviceEx(LPDIRECTINPUT7W iface, REFGUID rguid,
@@ -894,19 +893,19 @@ static HRESULT WINAPI IDirectInput7WImpl_CreateDeviceEx(LPDIRECTINPUT7W iface, R
 
     TRACE("(%p)->(%s, %s, %p, %p)\n", This, debugstr_guid(rguid), debugstr_guid(riid), pvOut, lpUnknownOuter);
 
-    return create_device(This, rguid, riid, pvOut, TRUE);
+    return create_device(This, rguid, riid, pvOut);
 }
 
 static HRESULT WINAPI IDirectInputAImpl_CreateDevice(LPDIRECTINPUT7A iface, REFGUID rguid,
                                                      LPDIRECTINPUTDEVICEA* pdev, LPUNKNOWN punk)
 {
-    return IDirectInput7AImpl_CreateDeviceEx(iface, rguid, NULL, (LPVOID*)pdev, punk);
+    return IDirectInput7AImpl_CreateDeviceEx(iface, rguid, &IID_IDirectInputDeviceA, (LPVOID *)pdev, punk);
 }
 
 static HRESULT WINAPI IDirectInputWImpl_CreateDevice(LPDIRECTINPUT7W iface, REFGUID rguid,
                                                      LPDIRECTINPUTDEVICEW* pdev, LPUNKNOWN punk)
 {
-    return IDirectInput7WImpl_CreateDeviceEx(iface, rguid, NULL, (LPVOID*)pdev, punk);
+    return IDirectInput7WImpl_CreateDeviceEx(iface, rguid, &IID_IDirectInputDeviceW, (LPVOID *)pdev, punk);
 }
 
 /*******************************************************************************
@@ -953,14 +952,14 @@ static HRESULT WINAPI IDirectInput8AImpl_CreateDevice(LPDIRECTINPUT8A iface, REF
                                                       LPDIRECTINPUTDEVICE8A* pdev, LPUNKNOWN punk)
 {
     IDirectInputImpl *This = impl_from_IDirectInput8A( iface );
-    return IDirectInput7AImpl_CreateDeviceEx( &This->IDirectInput7A_iface, rguid, NULL, (LPVOID*)pdev, punk );
+    return IDirectInput7AImpl_CreateDeviceEx(&This->IDirectInput7A_iface, rguid, &IID_IDirectInputDeviceA, (LPVOID *)pdev, punk);
 }
 
 static HRESULT WINAPI IDirectInput8WImpl_CreateDevice(LPDIRECTINPUT8W iface, REFGUID rguid,
                                                       LPDIRECTINPUTDEVICE8W* pdev, LPUNKNOWN punk)
 {
     IDirectInputImpl *This = impl_from_IDirectInput8W( iface );
-    return IDirectInput7WImpl_CreateDeviceEx( &This->IDirectInput7W_iface, rguid, NULL, (LPVOID*)pdev, punk );
+    return IDirectInput7WImpl_CreateDeviceEx(&This->IDirectInput7W_iface, rguid, &IID_IDirectInputDeviceW, (LPVOID *)pdev, punk);
 }
 
 static HRESULT WINAPI IDirectInput8AImpl_EnumDevices(LPDIRECTINPUT8A iface, DWORD dwDevType, LPDIENUMDEVICESCALLBACKA lpCallback,
diff --git a/dlls/dinput/dinput_private.h b/dlls/dinput/dinput_private.h
index e9205234a65..d174a809924 100644
--- a/dlls/dinput/dinput_private.h
+++ b/dlls/dinput/dinput_private.h
@@ -54,7 +54,7 @@ struct dinput_device {
     const char *name;
     HRESULT (*enum_deviceA)(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEA lpddi, DWORD version, int id);
     HRESULT (*enum_deviceW)(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEW lpddi, DWORD version, int id);
-    HRESULT (*create_device)(IDirectInputImpl *dinput, REFGUID rguid, REFIID riid, LPVOID *pdev, int unicode);
+    HRESULT (*create_device)(IDirectInputImpl *dinput, REFGUID rguid, REFIID riid, LPVOID *pdev);
 };
 
 struct DevicePlayer {
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index 76e7e2bcaab..d553c390892 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -588,11 +588,12 @@ static unsigned short get_joystick_index(REFGUID guid)
     return MAX_JOYSTICKS;
 }
 
-static HRESULT joydev_create_device(IDirectInputImpl *dinput, REFGUID rguid, REFIID riid, LPVOID *pdev, int unicode)
+static HRESULT joydev_create_device(IDirectInputImpl *dinput, REFGUID rguid, REFIID riid, LPVOID *pdev)
 {
     unsigned short index;
+    int unicode;
 
-    TRACE("%p %s %s %p %i\n", dinput, debugstr_guid(rguid), debugstr_guid(riid), pdev, unicode);
+    TRACE("%p %s %s %p\n", dinput, debugstr_guid(rguid), debugstr_guid(riid), pdev);
     find_joystick_devices();
     *pdev = NULL;
 
@@ -602,9 +603,7 @@ static HRESULT joydev_create_device(IDirectInputImpl *dinput, REFGUID rguid, REF
         JoystickImpl *This;
         HRESULT hr;
 
-        if (riid == NULL)
-            ;/* nothing */
-        else if (IsEqualGUID(&IID_IDirectInputDeviceA,  riid) ||
+        if (IsEqualGUID(&IID_IDirectInputDeviceA,  riid) ||
                  IsEqualGUID(&IID_IDirectInputDevice2A, riid) ||
                  IsEqualGUID(&IID_IDirectInputDevice7A, riid) ||
                  IsEqualGUID(&IID_IDirectInputDevice8A, riid))
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index a39b727e278..47e9020632c 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -606,11 +606,12 @@ static unsigned short get_joystick_index(REFGUID guid)
     return MAX_JOYDEV;
 }
 
-static HRESULT joydev_create_device(IDirectInputImpl *dinput, REFGUID rguid, REFIID riid, LPVOID *pdev, int unicode)
+static HRESULT joydev_create_device(IDirectInputImpl *dinput, REFGUID rguid, REFIID riid, LPVOID *pdev)
 {
     unsigned short index;
+    int unicode;
 
-    TRACE("%p %s %s %p %i\n", dinput, debugstr_guid(rguid), debugstr_guid(riid), pdev, unicode);
+    TRACE("%p %s %s %p\n", dinput, debugstr_guid(rguid), debugstr_guid(riid), pdev);
     find_joydevs();
     *pdev = NULL;
 
@@ -619,9 +620,7 @@ static HRESULT joydev_create_device(IDirectInputImpl *dinput, REFGUID rguid, REF
     {
         JoystickImpl *This;
 
-        if (riid == NULL)
-            ;/* nothing */
-        else if (IsEqualGUID(&IID_IDirectInputDeviceA,  riid) ||
+        if (IsEqualGUID(&IID_IDirectInputDeviceA,  riid) ||
                  IsEqualGUID(&IID_IDirectInputDevice2A, riid) ||
                  IsEqualGUID(&IID_IDirectInputDevice7A, riid) ||
                  IsEqualGUID(&IID_IDirectInputDevice8A, riid))
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index 0d14de6ba58..61da492a071 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -1274,12 +1274,13 @@ static unsigned short get_joystick_index(REFGUID guid)
     return 0xffff;
 }
 
-static HRESULT joydev_create_device(IDirectInputImpl *dinput, REFGUID rguid, REFIID riid, LPVOID *pdev, int unicode)
+static HRESULT joydev_create_device(IDirectInputImpl *dinput, REFGUID rguid, REFIID riid, LPVOID *pdev)
 {
     unsigned short index;
     int joystick_devices_count;
+    int unicode;
 
-    TRACE("%p %s %s %p %i\n", dinput, debugstr_guid(rguid), debugstr_guid(riid), pdev, unicode);
+    TRACE("%p %s %s %p\n", dinput, debugstr_guid(rguid), debugstr_guid(riid), pdev);
     *pdev = NULL;
 
     if ((joystick_devices_count = find_joystick_devices()) == 0)
@@ -1291,9 +1292,7 @@ static HRESULT joydev_create_device(IDirectInputImpl *dinput, REFGUID rguid, REF
         JoystickImpl *This;
         HRESULT hr;
 
-        if (riid == NULL)
-            ;/* nothing */
-        else if (IsEqualGUID(&IID_IDirectInputDeviceA,  riid) ||
+        if (IsEqualGUID(&IID_IDirectInputDeviceA,  riid) ||
                  IsEqualGUID(&IID_IDirectInputDevice2A, riid) ||
                  IsEqualGUID(&IID_IDirectInputDevice7A, riid) ||
                  IsEqualGUID(&IID_IDirectInputDevice8A, riid))
diff --git a/dlls/dinput/keyboard.c b/dlls/dinput/keyboard.c
index 63952f1f3ff..70223074e2e 100644
--- a/dlls/dinput/keyboard.c
+++ b/dlls/dinput/keyboard.c
@@ -280,19 +280,17 @@ failed:
     return NULL;
 }
 
-
-static HRESULT keyboarddev_create_device(IDirectInputImpl *dinput, REFGUID rguid, REFIID riid, LPVOID *pdev, int unicode)
+static HRESULT keyboarddev_create_device(IDirectInputImpl *dinput, REFGUID rguid, REFIID riid, LPVOID *pdev)
 {
-    TRACE("%p %s %s %p %i\n", dinput, debugstr_guid(rguid), debugstr_guid(riid), pdev, unicode);
+    int unicode;
+    TRACE("%p %s %s %p\n", dinput, debugstr_guid(rguid), debugstr_guid(riid), pdev);
     *pdev = NULL;
 
     if (IsEqualGUID(&GUID_SysKeyboard, rguid)) /* Wine Keyboard */
     {
         SysKeyboardImpl *This;
 
-        if (riid == NULL)
-            ;/* nothing */
-        else if (IsEqualGUID(&IID_IDirectInputDeviceA,  riid) ||
+        if (IsEqualGUID(&IID_IDirectInputDeviceA,  riid) ||
                  IsEqualGUID(&IID_IDirectInputDevice2A, riid) ||
                  IsEqualGUID(&IID_IDirectInputDevice7A, riid) ||
                  IsEqualGUID(&IID_IDirectInputDevice8A, riid))
diff --git a/dlls/dinput/mouse.c b/dlls/dinput/mouse.c
index 57da24ddee5..f5a49f51a07 100644
--- a/dlls/dinput/mouse.c
+++ b/dlls/dinput/mouse.c
@@ -238,18 +238,17 @@ failed:
     return NULL;
 }
 
-static HRESULT mousedev_create_device(IDirectInputImpl *dinput, REFGUID rguid, REFIID riid, LPVOID *pdev, int unicode)
+static HRESULT mousedev_create_device(IDirectInputImpl *dinput, REFGUID rguid, REFIID riid, LPVOID *pdev)
 {
-    TRACE("%p %s %s %p %i\n", dinput, debugstr_guid(rguid), debugstr_guid(riid), pdev, unicode);
+    int unicode;
+    TRACE("%p %s %s %p\n", dinput, debugstr_guid(rguid), debugstr_guid(riid), pdev);
     *pdev = NULL;
 
     if (IsEqualGUID(&GUID_SysMouse, rguid)) /* Wine Mouse */
     {
         SysMouseImpl *This;
 
-        if (riid == NULL)
-            ;/* nothing */
-        else if (IsEqualGUID(&IID_IDirectInputDeviceA,  riid) ||
+        if (IsEqualGUID(&IID_IDirectInputDeviceA,  riid) ||
                  IsEqualGUID(&IID_IDirectInputDevice2A, riid) ||
                  IsEqualGUID(&IID_IDirectInputDevice7A, riid) ||
                  IsEqualGUID(&IID_IDirectInputDevice8A, riid))
-- 
2.28.0

>From d4978e7d1190845ca61048ad4aa0b48a6c04576c Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Mon, 5 Oct 2020 12:44:47 +0200
Subject: [PATCH 05/39] dinput: Introduce dinput_create_device helper.

To simplify and factor device creation.
---
 dlls/dinput/device.c              | 20 ++++++++++++++-
 dlls/dinput/dinput_main.c         |  6 ++---
 dlls/dinput/dinput_private.h      |  7 +++++-
 dlls/dinput/joystick_linux.c      | 41 +++++--------------------------
 dlls/dinput/joystick_linuxinput.c | 41 +++++--------------------------
 dlls/dinput/joystick_osx.c        | 40 +++++-------------------------
 dlls/dinput/keyboard.c            | 41 +++++--------------------------
 dlls/dinput/mouse.c               | 41 +++++--------------------------
 8 files changed, 57 insertions(+), 180 deletions(-)

diff --git a/dlls/dinput/device.c b/dlls/dinput/device.c
index 6b71f93f24b..10b8580721a 100644
--- a/dlls/dinput/device.c
+++ b/dlls/dinput/device.c
@@ -239,7 +239,8 @@ const char *_dump_dinput_GUID(const GUID *guid) {
     return debugstr_guid(guid);
 }
 
-void _dump_DIDATAFORMAT(const DIDATAFORMAT *df) {
+void _dump_DIDATAFORMAT(const DIDATAFORMAT *df)
+{
     unsigned int i;
 
     TRACE("Dumping DIDATAFORMAT structure:\n");
@@ -1641,3 +1642,20 @@ HRESULT direct_input_device_alloc(SIZE_T size, const IDirectInputDevice8WVtbl *v
     *out = This;
     return DI_OK;
 }
+
+HRESULT dinput_create_device(const struct dinput_device *device, IDirectInputImpl *dinput, REFGUID guid, REFIID iid, void **out)
+{
+    IDirectInputDeviceImpl *This;
+    HRESULT hr;
+
+    if (!device->create_device) return E_FAIL;
+    if (FAILED(hr = device->create_device(dinput, guid, &This))) return hr;
+    if (!FAILED(hr = IDirectInputDevice8_QueryInterface(IDirectInputDevice8W_from_impl(This), iid, out)))
+    {
+        TRACE("created device %p\n", This);
+        if (TRACE_ON(dinput)) _dump_DIDATAFORMAT(This->data_format.wine_df);
+    }
+    /* IDirectInputDevice8_QueryInterface increased refcount */
+    IDirectInputDevice8_Release(IDirectInputDevice8W_from_impl(This));
+    return hr;
+}
diff --git a/dlls/dinput/dinput_main.c b/dlls/dinput/dinput_main.c
index c8ff3bd8bec..5d75cdf56e9 100644
--- a/dlls/dinput/dinput_main.c
+++ b/dlls/dinput/dinput_main.c
@@ -853,6 +853,7 @@ static HRESULT WINAPI IDirectInput2WImpl_FindDevice(LPDIRECTINPUT7W iface, REFGU
 static HRESULT create_device(IDirectInputImpl *This, REFGUID rguid, REFIID riid, LPVOID *pvOut)
 {
     unsigned int i;
+    HRESULT hr;
 
     if (pvOut)
         *pvOut = NULL;
@@ -866,10 +867,7 @@ static HRESULT create_device(IDirectInputImpl *This, REFGUID rguid, REFIID riid,
     /* Loop on all the devices to see if anyone matches the given GUID */
     for (i = 0; i < ARRAY_SIZE(dinput_devices); i++)
     {
-        HRESULT ret;
-
-        if (!dinput_devices[i]->create_device) continue;
-        if ((ret = dinput_devices[i]->create_device(This, rguid, riid, pvOut)) == DI_OK) return DI_OK;
+        if (SUCCEEDED(hr = dinput_create_device(dinput_devices[i], This, rguid, riid, pvOut))) return hr;
     }
 
     WARN("invalid device GUID %s\n", debugstr_guid(rguid));
diff --git a/dlls/dinput/dinput_private.h b/dlls/dinput/dinput_private.h
index d174a809924..ac967af4e8a 100644
--- a/dlls/dinput/dinput_private.h
+++ b/dlls/dinput/dinput_private.h
@@ -49,14 +49,19 @@ struct IDirectInputImpl
     struct list                 device_players; /* device instance guid to player name */
 };
 
+typedef struct IDirectInputDeviceImpl IDirectInputDeviceImpl;
+
 /* Function called by all devices that Wine supports */
 struct dinput_device {
     const char *name;
     HRESULT (*enum_deviceA)(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEA lpddi, DWORD version, int id);
     HRESULT (*enum_deviceW)(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEW lpddi, DWORD version, int id);
-    HRESULT (*create_device)(IDirectInputImpl *dinput, REFGUID rguid, REFIID riid, LPVOID *pdev);
+    HRESULT (*create_device)(IDirectInputImpl *dinput, REFGUID rguid, IDirectInputDeviceImpl **out);
 };
 
+extern HRESULT dinput_create_device(const struct dinput_device *device, IDirectInputImpl *dinput, REFGUID guid,
+        REFIID iid, void **out) DECLSPEC_HIDDEN;
+
 struct DevicePlayer {
     GUID instance_guid;
     WCHAR username[MAX_PATH];
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index d553c390892..efec79962dd 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -545,7 +545,6 @@ static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
     newDevice->generic.devcaps.dwFFDriverVersion = 0;
 
     if (TRACE_ON(dinput)) {
-        _dump_DIDATAFORMAT(newDevice->generic.base.data_format.wine_df);
        for (i = 0; i < (newDevice->generic.device_axis_count); i++)
            TRACE("axis_map[%d] = %d\n", i, newDevice->generic.axis_map[i]);
         _dump_DIDEVCAPS(&newDevice->generic.devcaps);
@@ -588,49 +587,21 @@ static unsigned short get_joystick_index(REFGUID guid)
     return MAX_JOYSTICKS;
 }
 
-static HRESULT joydev_create_device(IDirectInputImpl *dinput, REFGUID rguid, REFIID riid, LPVOID *pdev)
+static HRESULT joydev_create_device(IDirectInputImpl *dinput, REFGUID guid, IDirectInputDeviceImpl **out)
 {
     unsigned short index;
-    int unicode;
 
-    TRACE("%p %s %s %p\n", dinput, debugstr_guid(rguid), debugstr_guid(riid), pdev);
+    TRACE("%p %s %p\n", dinput, debugstr_guid(guid), out);
     find_joystick_devices();
-    *pdev = NULL;
+    *out = NULL;
 
-    if ((index = get_joystick_index(rguid)) < MAX_JOYSTICKS &&
+    if ((index = get_joystick_index(guid)) < MAX_JOYSTICKS &&
         joystick_devices_count && index < joystick_devices_count)
     {
         JoystickImpl *This;
-        HRESULT hr;
-
-        if (IsEqualGUID(&IID_IDirectInputDeviceA,  riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice2A, riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice7A, riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice8A, riid))
-        {
-            unicode = 0;
-        }
-        else if (IsEqualGUID(&IID_IDirectInputDeviceW,  riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice2W, riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice7W, riid) ||
-                 IsEqualGUID(&IID_IDirectInputDevice8W, riid))
-        {
-            unicode = 1;
-        }
-        else
-        {
-            WARN("no interface\n");
-            return DIERR_NOINTERFACE;
-        }
-
-        hr = alloc_device(rguid, dinput, &This, index);
+        HRESULT hr = alloc_device(guid, dinput, &This, index);
         if (!This) return hr;
-
-        if (unicode)
-            *pdev = &This->generic.base.IDirectInputDevice8W_iface;
-        else
-            *pdev = &This->generic.base.IDirectInputDevice8A_iface;
-
+        *out = &This->generic.base;
         return hr;
     }
 
